import { Component } from '@a11d/lit';
import { ExtendsAttributeController } from '@3mo/extends-attribute-controller';
import { MaterialIcon } from '@3mo/icon';
export declare const enum ButtonType {
    Normal = "normal",
    Outlined = "outlined",
    Raised = "raised",
    Unelevated = "unelevated"
}
/**
 * @attr type
 * @attr disabled
 * @attr leadingIcon
 * @attr trailingIcon
 *
 * @slot - The content of the button.
 * @slot leading - The leading content of the button.
 * @slot trailing - The trailing content of the button.
 *
 * @cssprop --mo-button-accent-color
 * @cssprop --mo-button-horizontal-padding
 * @cssprop --mo-button-disabled-background-color
 * @cssprop --mo-button-disabled-color
 *
 * @csspart button - The composed native button element.
 */
export declare class Button extends Component {
    type: ButtonType;
    disabled: boolean;
    leadingIcon?: MaterialIcon;
    trailingIcon?: MaterialIcon;
    static get styles(): import("@a11d/lit").CSSResult;
    protected readonly extendsAttributeController: ExtendsAttributeController;
    protected get template(): import("lit-html").TemplateResult<1>;
    protected get isDisabled(): boolean;
    protected get contentTemplate(): import("lit-html").TemplateResult<1>;
    protected get leadingSlotTemplate(): import("lit-html").TemplateResult<1>;
    protected get leadingIconTemplate(): import("lit-html").HTMLTemplateResult;
    protected get slotTemplate(): import("lit-html").TemplateResult<1>;
    protected get trailingSlotTemplate(): import("lit-html").TemplateResult<1>;
    protected get trailingIconTemplate(): import("lit-html").HTMLTemplateResult;
}
declare global {
    interface HTMLElementTagNameMap {
        'mo-button': Button;
    }
}
//# sourceMappingURL=Button.d.ts.map